export interface RenderElements {
    grid: HTMLDivElement
    view: HTMLDivElement
    values: HTMLDivElement
}

export interface ChangoItem {
    kind: string
    wave: Array<number | string>
    lineVao: WebGLVertexArrayObject
    maskVao: WebGLVertexArrayObject
}

export interface WireInfoItem {
    kind: string
    link: string
    name: string
    size: number
    parent: WireInfoItem
    type: string
}

export interface Pstate {
    width: number
    height: number
    xScale: number
    xOffset: number
    yOffset: number
    yStep: number
    yDuty: number
}

export interface WebGLLocation {
    colors: WebGLUniformLocation
    shifts: WebGLUniformLocation
    scale: WebGLUniformLocation
    offset: WebGLUniformLocation
    pos: number
    widthShifts: WebGLUniformLocation
    gl: WebGL2RenderingContext
}

export interface PerspectivePoint {
    x: number
    y: number
    color: number
}