function getRatio() {
    var ratio=0;
    var screen=window.screen;
    var ua=navigator.userAgent.toLowerCase();
    if(window.devicePixelRatio !== undefined) {
        ratio=window.devicePixelRatio;    
    }
    else if(~ua.indexOf('msie')) {
        if(screen.deviceXDPI && screen.logicalXDPI) {
            ratio=screen.deviceXDPI/screen.logicalXDPI;        
        }
    
    }
    else if(window.outerWidth !== undefined && window.innerWidth !== undefined) {
        ratio=window.outerWidth/window.innerWidth;
    }

    if(ratio) {
        ratio=Math.round(ratio*100);    
    }
    return ratio;
}

const screenHeightPixel = window.screen.height * getRatio() / 100;
const screenWidthPixel = window.screen.width * getRatio() / 100;

// 控制颜色
const gl_Colors = new Float32Array([
    0, 0, 0, 0,            // 0: 空

    0, 0, 1, 1,            // 1: 高阻态 Z
    0.2, 0.847, 0.1,  1,   // 2: value = 0 用于 width = 1 的信号
    0.2, 0.847, 0.1,  1,   // 3: value = 1 用于 width = 1 的信号
    0.9, 0.2, 0.2, 1,      // 4: 未知态 X
    .5, 1, 1, 1,           // 5: vec 用于 width > 1 的信号
    
    1, 1, 0, 1,            // 6: yellow
    1, 0, 1, 1,            // 7: strange purple

    0, 1, 0, .5,           // 8: (l L) weak 0
    0, 1, 1, .5,           // 9: (h H) weak 1
    1, 0, 0, .5,           // 10: (w W) weak unknown

    0, 0, 1, 0.1,          // 11: 高阻态 Z 遮罩
    0.2, 0.847, 0.1,  0.1, // 12: value = 0 遮罩
    0.2, 0.847, 0.1,  0.1, // 13: value = 1 遮罩
    0.9, 0.2, 0.2, 0.1,    // 14: 未知态 X 遮罩
    .5, 1, 1, 0.1          // 15: vec 遮罩
]);


// 控制方向
const gl_Shifts = new Float32Array([ // 14
    0, 0,  // 0
    1, -1, // 1
    1, 0,  // 2
    1, 1,  // 3
    -1, -1, // 4
    -1, 0,  // 5
    -1, 1   // 6
]);

const gl_Shifts_map = new Map();
gl_Shifts_map.set(-1, 4);
gl_Shifts_map.set(0, 0);
gl_Shifts_map.set(1, 1);

const lineWidth = 0.004 * 3800 / screenWidthPixel;            // 不能写为 0.0045 这样会因为插值造成不同线段的宽度不一致的问题
const widthShift = lineWidth / 2;
const gl_WidthShifts = new Float32Array([
    0, widthShift,                  // 0
    - widthShift, widthShift,       // 1
    - widthShift, 0,                // 2
    - widthShift, - widthShift,     // 3
    0, - widthShift,                // 4
    widthShift, - widthShift,       // 5
    widthShift, 0,                  // 6
    widthShift, widthShift          // 7
]);


export {
    getRatio,
    gl_Colors,
    gl_Shifts,
    lineWidth,
    widthShift,
    gl_WidthShifts,
    gl_Shifts_map,
    screenWidthPixel,
    screenHeightPixel
};